<template>
	<div>
		<div
			v-if="PROMOTION_MESSAGE != ' '"
			class="text-center group -mx-4 mt-2 md:mt-6 lg:mt-2 md:mb-6"
			@click="upsellHeader()"
			@keypress.enter="upsellHeader()"
		>
			<h2 class="text-base font-primary-font-regular border-b inline-block border-violet mx-4 cursor-pointer pb-1">
				{{ PROMOTION_MESSAGE }}
			</h2>
			<div v-if="flag">
				<div class="flex items-center justify-center bg-grey-10 flex-col py-6 px-10 mt-4 w-full relative">
					<svg
						x="0px"
						y="0px"
						viewBox="0 0 255 255"
						xml:space="preserve"
						class="absolute text-grey-10 h-7 transform -top-7 rotate-180"
					>
						<polygon points="0,0 127.5,127.5 255,0" class="fill-current"></polygon>
					</svg>
					<button
						class="top-4 right-4 absolute"
						aria-label="Close"
						@click="closePromotion()"
						@keypress.enter="closePromotion()"
					>
						<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 12 11" class="w-3.5 h-3.5 fill-current">
							<g fill="none" fill-rule="evenodd">
								<g fill="#000">
									<g>
										<g>
											<g>
												<path
													d="M10.125 3.25c.552 0 1 .448 1 1l-.001 4.624 4.626.001c.552 0 1 .448 1 1v.25c0 .552-.448 1-1 1l-4.626-.001.001 4.626c0 .552-.448 1-1 1h-.25c-.552 0-1-.448-1-1l-.001-4.626-4.624.001c-.552 0-1-.448-1-1v-.25c0-.552.448-1 1-1l4.624-.001.001-4.624c0-.552.448-1 1-1h.25z"
													transform="translate(-345 -363) translate(15 268) translate(92 89.554) translate(234 .661) rotate(45 10 10)"
												></path>
											</g>
										</g>
									</g>
								</g>
							</g>
						</svg>
					</button>
					<h3 class="text-2xl font-secondary-font-regular">
						What a pair: {{ productDetails && productDetails.productName }}
					</h3>
					<MKProductImage
						size-class="w-32 py-4"
						:product-sku="productDetails.productSku"
						:product-name="productDetails.productName"
					/>
					<p class="text-sm font-primary-font-light mb-4">
						{{ productDetails && productDetails.promotionMessage }}
					</p>
					<MkPrimaryButton
						btn-class="h-8 text-sm font-primary-font-regular"
						button-title="Add to Cart"
						:loading="addingToCart"
						@click="addBundleToCart"
					/>
				</div>
			</div>
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MKProductImage from '~/components/D2C/organisms/MkProductImage/MkProductImage.vue';
export default {
	name: 'MkWhatPair',
	components: {
		MkPrimaryButton,
		MKProductImage,
	},
	props: {
		productDetails: {
			type: Object,
			default: null,
		},
	},
	data() {
		return {
			addingToCart: false,
			heading: 'Get the bundle.',
			flag: false,
		};
	},
	computed: {
		...mapState('CART_STORE', ['LINE_ITEMS', 'PROMOTION_MESSAGE', 'PROMOTION_PRODUCT']),
	},
	methods: {
		async addBundleToCart() {
			this.addingToCart = true;
			const BundlePayload = {
				action: 'ADD_LINE_ITEM',
				productId: this.productDetails.productId,
				quantity: 1,
				variantId: 1,
			};
			await this.$store.dispatch('CART_STORE/ADD_REMOVE_FROM_CART', BundlePayload);
			this.addingToCart = false;
			this.flag = false;
		},
		upsellHeader() {
			if (!this.addingToCart) {
				this.flag = !this.flag;
				if (!this.flag) {
					this.heading = 'Get the bundle.';
				} else {
					this.heading = 'Now that’s fresh.';
				}
			}
		},
		closePromotion() {
			this.flag = true;
		},
	},
};
</script>
